Changes from 3.4.1 to 3.4.2

*Kernel:
- Fixed sorting of collected information result
- Fixed bug with drop down placements when editng a node, it now works setting the main node
- Fixed bug in cache system, it always expired all cache on publishing.
- Made sure the user/success page follows the SiteSettings/LoginPage setting.
- Added detection of APC in the system information page.
  (Merged from stable/3.3 rev. 7179)
- Fixed problem with the eZNodeViewFunctions class making a copy of the
  $tpl input parameter.
- Added PHP script for clearing caches (bin/php/ezcache.php), this script
  uses the internal code in eZ publish for clearing caches and should be
  more reliable.
- Fixed bug in ezdesign operator which caused eZTemplateDesignResource
  instance to be overwritten.
- Fixed problem with fetch function content/checkAccess and the
  content class id parameter being false.
- Fixed problem with character set conversion which was always done when using utf-8
- Added indexcontent.php to cronjobs.ini
- Fixed cronjobs/indexcontent.php to be more fault tolerant and scale better.
- Optimized links in xmltext fields. Instead of two queries per URL we only do
  one query per content attribute now.

Database:
- Added index on ezcontentobject_tree( path_identification_string ).

eZ template compiler:
- Added support for compiling a specific template.
  (Merged from trunk/3.5)
- Added support for forcing a recompile with --force.
  (Merged from trunk/3.5)

Class:
- Storing a class will now jump to the class view instead of the group/class listing.
  (Merged from stable/3.3 rev. 7185)

Workflow:
- Fixed ezsimpleshipping event to work with the 'before' trigger confirmorder
  and not the 'after' trigger.

Setup:
- Added information on Apache webserver to registration email (if Apache is used).
  (Merged from stable/3.3 rev. 7242)
- Added sanity check for the session extension. If this is missing a
  warning is shown. (Required for some SuSe builds).

Scripts:
- New PHP script bin/php/eztemplatecheck.php which validates template files.

*Design:
edit_placement.tpl:
- Change the default to show all node assignments, not just the ones without
  remote ID. This means that when editing an object in admin interface
  without a special override will work.
  Merged from stable/3.3 rev. 7127.

*Bugfixes:
- Added whitespace removal to mail Transport setting (in site.ini file) - 
  it is critical that there's no whitespace there.
- Fixed notification digest bug, merged from stable/3.3 rev. 7092.
- Fixed so that displaying images with center alignment now works properly.
  http://ez.no/community/bug_reports/ez_no_image_display_overlap_on_new_browsers
- Fixed bug in {section show=$abc } where $abc is undefined. Bug only
  occured when template compilation was disabled.
- Fixed bug with misquoted filenames in Content-disposition header. (Merged from stable/3.3, rev 7107)
  http://ez.no/community/bug_reports/content_disposition_in_kernel_classes_binaryhandlers_ezfilepasstrough
- Fixed hard coded "alternative name" for Company Logo.
  http://ez.no/community/bug_reports/alt_image_text_for_company_logo_is_hardcoded
- Fixed problems with overwritten uploaded files. (Merged from stable/3.3, rev 7120)
  http://ez.no/community/bug_reports/new_binary_files_sometimes_overwrite_existing_binary_files
- Fixed problem with ANSI control chars for the shell scripts. (Merged from unstable/3.5, rev 7130)
  http://ez.no/community/bug_reports/cli_scripts_in_windows_dos_box_show_ansi_control_characters
- Fixed problem with section placements for new related objects. (Merged from stable/3.3, rev. 7138)
  http://ez.no/community/bug_reports/related_object_added_to_article_set_to_section_0
- Fixed wrong check for INI setting.
  http://ez.no/community/bug_reports/usefullurl_in_kernel_layout_set_php
- Fixed superfluous variable and INI class instantiation.
  http://ez.no/community/bug_reports/unused_variable_enablecaching_in_ezrole_fetchbyuser
- Fixed another bug related to the ezcontentobjectlrelationlist template.
  http://ez.no/community/bug_reports/template_compiler_bug_when_class_list_is_passed_to_fetch_in_a_variable_containing_hash
- Fixed bogus PostGreSQL version check. (Merged from stable/3.3, rev. 7154)
  http://ez.no/community/bug_reports/fail_installation_with_postgresql_db
- Fixed bug with variables set by toolbar template function not being unset.
  http://ez.no/community/bug_reports/bug_in_template_compiler
- Fixed tip-a-friend email to generate proper links to the object (including www-dir and index-file)
  http://ez.no/community/bug_reports/missing_ezurl_in_template_design_standard_templates_content_tipafriendmail_tpl
- Fixed missing information collector result template for ezemail datatype.
  http://ez.no/community/bug_reports/information_collection_ezemail_template_missing
- Fixed wrong urls in registration emails.
  http://ez.no/community/bug_reports/user_confirmation_e_mail_sends_bugged_link
- Updated the LDAP and textfile user handlers to use the new login code for 3.4
  http://ez.no/community/bug_reports/ldap_login_handler_doesn_t_work
- Fixed problem with user specified parameters when URL translator is disabled.
  http://ez.no/community/bug_reports/role_list_does_not_work_with_disabled_url_translation
- Fixed use of uninitialized variable for si operator.
  http://ez.no/community/bug_reports/binary_file_size_display
- Fixed clearing of subtree expiry caches when clearing template block cache in admin.
  http://ez.no/community/bug_reports/clear_cache_cache_blocks_table_ezsubtree_expiry_isn_t_cleared
- Fixed bug in base templates (concat vs array)
  http://ez.no/community/bug_reports/edit_language_problem_in_base_templates
- Removed debug output from eZMatrix datatype
  http://ez.no/community/bug_reports/remove_verbose_line_from_ezmatrixtype_php
- Fixed missing quotes and washing in link tool.
  http://ez.no/community/bug_reports/toolbar_line_link_tpl_href_need_to_put_quotes_around_to_validate
- Fixed ezenum class view template to not show HTML input elements.
  http://ez.no/community/bug_reports/enum_attributes_are_editable_when_viewing_not_editing_a_class
- Fixed URL management (/url/list) bug: 'All' showed only invalid URLs. Should show all URLs.
- Removed unused checkboxes and commented template code in 'url management'
  http://ez.no/community/bug_reports/unused_url_list_checkboxes
  (Merged from stable/3.3 rev. 7238)
- Fixed problem with the subtree notification handler not including the ID of
  the changed node when finding subscribed users.
  http://ez.no/community/bug_reports/bug_notifications_still_not_working_properly
  (Merged from stable/3.3 rev. 7246)
- Fixed problem with eZSubTree datatype, it used the method call
  eZSubtreeNotificationRule::removeByNodeAndAddress which did not exist.
  (Merged from stable/3.3 rev. 7250)
- Fixed division by zero in poll results template (base)
  http://ez.no/community/bug_reports/tc_division_by_zero_poll
- Fixed bug with regards to template operators without input parameter
  used as attribute lookup value.
  http://ez.no/community/bug_reports/compiled_template_problem
- Fixed name of member variable UserParams to UserArray in eZURI class.
  http://ez.no/community/bug_reports/bug_in_ezuri_class
- Fixed bug with template parser not allowing whitespace after the single tag
  marker.
  http://ez.no/community/bug_reports/wrong_case_syntax_causes_template_compile_error
  (Merged from stable/3.3 rev. 7272)
- Fixed some of the issues in this bugreport.
  http://ez.no/community/bug_reports/bugs_in_kernel__2
  (Merged from stable/3.3 rev. 7295)
- Fixed incorrect API doc for eZUser.
  http://ez.no/community/bug_reports/ezuser_api_correction
  (Merged from stable/3.3 rev. 7316)
- Fixed problem with autolink operator not allowing semi-colons in the url.
  http://ez.no/community/bug_reports/xml_text_text_to_a_links_does_not_work_correctly
- Fixed typos in mysql/kernel_schema.sql (merged from stable/3.3 rev. 7374).
- Fixed bug in toolbar calendar.
- Fixed bug in div and mul template operators when input parameter was used.
  http://ez.no/community/bug_reports/operator_mul_does_not_work_as_documented
  (Merged from stable/3.3 rev. 7387)
- Fixed bug in rendering Tables in PDF export.
  http://ez.no/community/bug_reports/pdf_article_displays_code
- Fixed bug with permission cleanup on node removal
  http://ez.no/community/bug_reports/roles_policies_subtree_limit_bug
- Fixed bug with ezauthor and search meta data.
  http://ez.no/community/bug_reports/search_ezauthor
  (Merged from stable/3.3 (3.3-6) rev. 7516)
- Fixed writing the expiry.php file to be an atomic operation so that multiple
  content updates can not mangle the file. (Backported from 3.5/rev. 7576)
- Fixed bug where object tag was always handled as a block tag
  http://ez.no/community/bug_reports/un_wanted_line_breaks_added_in_xml_text_field
- Fixed wrong permission for file /update/common/scripts/addordermail.php
  http://ez.no/community/bug_reports/permission_denied_running_update_common_scripts_addorderemail_php
- Fixed concurrency issue with cached files. (Reimplementation from trunk/3.5, rev. 7613)
  http://ez.no/community/bug_reports/critical_at_high_traffic_sites_files_aren_t_locked_at_writing_process
- Fixed faulty index on table ezurl_object_link.
- Fixed bug with missing ul start tag
  http://ez.no/community/bug_reports/missing_ul_in_eztemplatetoolbarfunction_php
- Reverted workflow fix in bug report : http://ez.no/community/bug_reports/bugs_in_kernel__2
- Now it is possible to display output from checkbox datatype after clicking on send button from information collector form.
  (Merged from trunk(3.5) rev. 7606)
- Fixed fetch with list and list_count if classfilter contains non-existing classes
  http://ez.no/community/bug_reports/classfilter_doesn_t_work_if_invalid_classidentifer_is_supplied_in_fetch
- Fixed double listing of the notification tool.
  http://ez.no/community/bug_reports/notification_toolbox_is_listed_twice
- Fixed broken XHTML code.
  http://ez.no/community/bug_reports/layout_break_in_line_file_tpl
- Fixed bug with incorrect fetching of user roles when user is more then in one user group.
  http://ez.no/community/bug_reports/adding_a_user_to_a_user_group_doesn_t_automatically_apply_all_roles 
- Fixed problem with cached templates and /layout/set/print (Merged from 3.5, rev. 7765)
  http://ez.no/community/bug_reports/ez_no_wrong_links_in_contrib_section
- Fixed MySQL 4.1 incompatibility.
  http://ez.no/community/bug_reports/mysql_4_incompatibility
- Fixed a warning with conditional overrides.
  http://ez.no/community/bug_reports/php_warning_eztemplatedesignresource_php
- Fixed a couple of warnings about the navigationPartIdentifier
  http://ez.no/community/bug_reports/with_debug_enabled_i_am_getting_the_following_error
- Fixed bug in cache block with subtree expiry. Subtree expiry partly rewritten.
  http://ez.no/community/bug_reports/cache_block_subtree_expiry_after_deleting
- Removed unused file kernel/classes/datatypes/ezuser/ezaccounthash.php
  http://ez.no/community/bug_reports/wrong_user_class
  (Merged from stable/3.3 rev. 7860)
- Fixed bug where we relied on http being available in the AcceptPathInfo
  set-up test.
  http://ez.no/community/bug_reports/acceptpathinfo_and_https
- Fixed wrong detection of memory limit and timeout settings in setup wizzard
  http://www.ez.no/community/bug_reports/memory_limit_detection_wrong_in_setup_wizard
- Fixed bug where user can not create comments in weblog
  http://www.ez.no/community/bug_reports/users_cannot_add_comments_use_weblog
- Merged another forgotten use of UseFullUrl
  http://ez.no/community/bug_reports/layout_fullurl_template_compiling_errors
- Added missing sender and reply to when sending informationcollector mail
  http://www.ez.no/community/bug_reports/information_collection_mail_sender_is_empty
- Added new 'smart clear cache logic' to solve some bugs related to view caching
  (Merged from trunk/3.5, rev. 7858)
- Added all RFC 2396 allowed characters to the autolink operator.
  http://www.ez.no/community/bug_reports/autolink_operator__2
- Fixed bug of ezdate and ezdatetime datatypes indexing in the search
  engine.
  (Merged from stable/3.4 rev. 7903)
  http://ez.no/community/bug_reports/index_of_ezdate_ezdatetime
- Fixed bug of incorrectly display version infomation if user can not delete version.
  (Merged from stable/3.3 rev. 7910)
  http://ez.no/community/bug_reports/faulty_display_of_versions_if_user_cannot_delete
- Fixed bug with incorrectly built SQL query in xml output handler with links.
  http://ez.no/community/bug_reports/incorrectly_built_sql_query
- Fixed bug with class filter in subTree and subtree count functions.
  (Manualy merged from trunk/3.5, rev. 7931)
  http://ez.no/community/bug_reports/critcal_sql_error_in_ezcontentobjecttreenode_subtree_and_ezcontentobjecttreenode_subtreecount
- Fixed bug of combination of node with section or class in permission policy caused wrong read access.
  (Merged from stable/3.3, rev. 7962)
  http://www.ez.no/community/bug_reports/node_and_section_policy_limitation_causes_unwanted_read_access
- Fixed bug of template variable cache_ttl not working in 3.4
  http://www.ez.no/community/bug_reports/there_seems_to_be_a_bug_with_the_cache_ttl_template_var
- Fixed call to non-object when viewing an URL not used by any objects.
  http://www.ez.no/community/bug_reports/link_and_objectversion
- Fixed bug related to wrong deletion of rows in eZMatrix datatype
  http://ez.no/community/bug_reports/martix_rows_reappear_after_deleting
- Added missing template node/view/listitem.tpl
  http://ez.no/community/bug_reports/missing_template_file
- Fixed some warnings / errors with empty template files
  http://ez.no/community/bug_reports/empty_template_causes_malfunction
- Fixed bug with eZEmailType which required a auser to enter an address even if the datatype
  was marked as information collector.
  http://www.ez.no/community/bug_reports/if_datatype_email_is_information_collector_and_not_required_it_can_t_be_empty
- Fixed bug in eZMatrix datatype when adding/removing/changing columns.
  http://ez.no/community/bug_reports/new_matrix_columns_dont_show_in_existing_objects
- Fixed bug of adding related objects not able to get correct section ID.
  http://www.ez.no/community/bug_reports/adding_items_via_related_object_new_button_fails_to_set_section
- Fixed bug with {set} in template compiler.
  http://ez.no/community/bug_reports/set_statement_does_not_work_in_some_cases
  http://www.ez.no/community/bug_reports/template_compiling_problem
- Fixed bug in ezcontentrelationtype's usage of ezcontentobjecttreenode::subtree().
  http://www.ez.no/community/bug_reports/objectrelationtype_and_fuzzy_match
- Fixed bug with list_count fetch function in content so it allows array of 
  parent_node_id's as argument.
  http://ez.no/community/bug_reports/parent_node_id_array_use_inconsistent
- Fixed bug with recursively linked objects.
  http://www.ez.no/community/bug_reports/object_relation_list_causes_document_contains_no_data_error
- Fixed bug of override template by class_identifer does not work in some cases.
  ht://www.ez.no/community/bug_reports/class_identifier_and_override_problems
- Fixed typo in error message. (Merged from trunk/3.5, rev. 7989)
  http://ez.no/community/bug_reports/the_fatal_error_ez_publish_did_not_finish_it_s_request_message
- Fixed PHP version check.
  http://ez.no/community/bug_reports/ezsetup_vs_doc_minimum_requirement_of_phpversion
- Fixed bug: eZContentObject::fetch() didn't respect $asObject argument value.
  http://ez.no/community/bug_reports/ezcontentobject_fetch_doesnt_respect_asobject_value
- Fixed bug of loading cache file in toolbar management which causes lots of debug errors.
  http://www.ez.no/community/bug_reports/problem_with_toolbar_management
- Fixed bug: We now don't allow database "mysql" to be chosen during setup.
  http://ez.no/community/bug_reports/during_the_setup_it_is_possible_choose_to_use_the_mysql_database
- Fixed bug:  Removal of subtree limitation removes limitation from all roles.
  http://ez.no/community/bug_reports/removal_of_subtree_limitation_removes_limitation_from_all_roles
- Fixed bug: objects in object relations had their class_name attribute set to NULL.
  http://ez.no/community/bug_reports/objects_in_object_relations_have_their_class_name_attribute_set_to_null
- Fixed bug: eZContentObject::fetchSameClassListCount() returned array instead of integer.
- Fixed bug: Object relation selection method was not stored when clicking 'Store' button.
  http://ez.no/community/bug_reports/object_relation_selection_method_not_free_to_choose
- Fixed typo in ezmodule.php
  http://ez.no/community/bug_reports/non_fatal_doxygen_comment_in_ezmodule_php
- Fixed bug: eZtime, eZdate and eZdateTime datatypes had incorrect object validation.
  http://ez.no/community/bug_reports/datatypes_eztime_ezdate_and_ezdatetime_have_incorrect_object_validation
- Fixed bug: non-eZ database tables were deleted when selecting remove data in the setup wizard.
  (Merged from stable/3.3 rev. 8039)
  http://ez.no/community/bug_reports/other_database_tables_deleted_when_selecting_remove_data_in_setup_wizard
- Fixed bug  eZText datatype bug when disabled translation.
  http://ez.no/community/bug_reports/eztext_datatype_bug_when_disabled_translation
- Fixed bug with tipafriend when changing the class for user.
  http://ez.no/community/bug_reports/tipafriend_php_contains_hardcoded_class_information
- Fixed bug: dirty cache after node where moved.
- Fixed bug with missing include of eZ xml.
  http://ez.no/community/bug_reports/cannot_instantiate_non_existent_class_ezxml_in_ezdatetimetype_php
- Changed default PostgreSQL user from 'root' to 'postgres' in bin/shell/redumpall.sh since
  there's no user called root in default PostgreSQL installation.
  (Merged from stable/3.3 rev. 8108)
- Fixed bug: While deleting the class, all objects of that class in trash will also be deleted.
  http://ez.no/community/bug_reports/removing_class_does_not_remove_objects_in_trash

*Lib:

eZ template:
- Fixed problem with array/hash creation in template compiler.
- Fixed bug in switch function when using in parameter and no subkey.
  (Merged from stable/3.3 rev. 7190)
- Fixed bug with let not cleaning up its variables in compiled mode.
- Fixed bug with template processing and input variable to operators,
  if the input variable was a template proxy object the template value 
  was not dereferenced.
- Added the possibility to fetch the number of errors and warnings from
  the last fetch.
- Created function for doing validation on a given template file.
- Fixed problem with fetch() and fetch_alias() operators when the parameter
  hash was a dynamic expression (e.g. cond).
  (Merged from trunk (3.5) rev. 7562)
- Changed the code to make it database independant (changed for stable/3.4 rev. 8129).
  http://ez.no/community/bug_reports/removing_class_does_not_remove_objects_in_trash

eZPDF:
- Fixed margins using ul operator.
